package dev.fyloz.trial.colorrecipesexplorer.core.model;

import lombok.*;
import org.hibernate.annotations.ColumnDefault;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.Objects;

@Entity
@Data
@NoArgsConstructor
@RequiredArgsConstructor
@AllArgsConstructor
public class MaterialType implements IModel {

    public static final String IDENTIFIER_PREFIX_NAME = "prefix";

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    private Long id;

    @NonNull
    @NotNull
    @Column(unique = true)
    private String name;

    @NonNull
    @NotNull
    @Column(unique = true)
    private String prefix;

    @NonNull
    @NotNull
    @ColumnDefault("false")
    private boolean usePercentages;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        MaterialType that = (MaterialType) o;
        return name.equals(that.name) &&
                prefix.equals(that.prefix);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name, prefix);
    }
}
