package dev.fyloz.trial.colorrecipesexplorer.services;

import dev.fyloz.trial.colorrecipesexplorer.builders.MixTypeBuilder;
import dev.fyloz.trial.colorrecipesexplorer.core.model.MixType;
import dev.fyloz.trial.colorrecipesexplorer.core.services.model.MaterialService;
import dev.fyloz.trial.colorrecipesexplorer.core.services.model.MixTypeService;
import dev.fyloz.trial.colorrecipesexplorer.dao.MixTypeDao;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.boot.test.mock.mockito.SpyBean;

public class MixTypeServiceTest extends AbstractServiceTest<MixType, MixTypeService, MixTypeDao> {

    @MockBean
    private MixTypeDao mixTypeDao;

    @Autowired
    @SpyBean
    private MixTypeService mixTypeService;

    @MockBean
    private MaterialService materialService;

    @BeforeEach
    void setUp() {
        mixTypeService.setMixTypeDao(mixTypeDao);
        mixTypeService.setMaterialService(materialService);

        super.init(mixTypeService, mixTypeDao);


    }


    @Test
    public void whenExistsByName_thenReturnTrue() {
        // given

        // when

        // then

    }


    @Override
    protected MixType getEntity() {
        return new MixTypeBuilder().build();
    }

    @Override
    protected MixType getEntityDifferentId() {
        return new MixTypeBuilder()
                .id(1L)
                .build();
    }

    @Override
    protected MixType getEntityNullId() {
        return new MixTypeBuilder()
                .id(null)
                .build();
    }
}
